import java.util.Scanner;

/**
 * EasyProblemUsingMethods - demo passing arrays to/from methods
 *
 * Note: This provides a means to map the code to your top-down design.
 *
 * @author David
 * @version 1.00 2012/12/3
 */

public class EasyProblemUsingMethods
{
	// ***************************************************************
   	private static int[] readSetOfValues()
	{
		Scanner scan = new Scanner( System.in);

		int		noOfValues;
		int[]	setOfValues;

		System.out.print( "Enter no of values: ");
		noOfValues = scan.nextInt();

		setOfValues = new int[noOfValues];

		System.out.println( "Enter set of values: ");
		for ( int i = 0; i < setOfValues.length; i++)
		{
			setOfValues[i] = scan.nextInt();
		}
		System.out.println();

		return setOfValues;
	}


	// ***************************************************************
	private static double computeAverage( int[] tempValues)
	{
		int		sum;
		double	average;

		sum = 0;
		for ( int i = 0; i < tempValues.length; i++)
		{
			sum = sum + tempValues[i];
		}
		average = (double) sum / tempValues.length;

		return average;
	}


	// ***************************************************************
	private static void printTable( double average,
									int[]  setOfValues)
	{
		System.out.println( "Average = " + average);
		System.out.println();
		for ( int i = 0; i < setOfValues.length; i++)
		{
			System.out.println( setOfValues[i]
								+ "\t"
								+ (setOfValues[i] - average) );
		}
	}


	// ***************************************************************
    public static void main( String[] args)
	{
    	System.out.println( "Start of EasyProblem\n");

		// VARIABLES
		int[]	setOfValues;
		double	average;

		// PROGRAM CODE

		// 1. read setOfValues
		setOfValues = readSetOfValues();

		// 2. compute average
		average = computeAverage( setOfValues);

		// 3. print table
		printTable( average, setOfValues);

		System.out.println( "\nEnd of EasyProblem\n" );
	}

	// ***************************************************************
} // end of class EasyProblem
